# Mybot Simulator

A physics-based 3D simulator for Robotican's Mybot robot.

![](demo.gif)

## Notes:

* This simulation was tested and intended to work under Linux Ubuntu 16.04.6 LTS/Mint 18.4

* Whenever `mybot_sim` directory mentioned in this README file, it referes to the root directory of this package.

## Directories Tree

There are 3 main directories in the package:

1. ***argos3*** - contain argos simulation files


## Installation

Run the installation script:

```

```

## Uninstall

Run the uninstall script:

```
```


## Sourcing setup_env.sh

This file contain argos enviorment variables, and should be sourced before using argos3.
If installation script finished successfuly, it also automatically source setup_env.sh file for the first time.
After that, whenever you open new terminal, you have to source the file again. This can be done by writing:

```
```

To avoid sourcing the file for every new terminal manually, you can add the source command to your .bashrc file.

## Open Source License

[MIT License](LICENSE)

## Where Do I Go From Here?

The [docs/](docs/) folder contains documentation. Including the following topics:
## TODO!!!!
1. [Install mybot Woekspace](docs/install_workspace.md)
2. [Create and run new mybot program](mybot/README.md)
3. [Use multiple controllers in the same program](docs/multi_controllers.md)
4. [Porting files from real mybot to simulator, and vice-versa](docs/porting.md) 
5. [Calibrating wheels speed](docs/wheels_calib.md) 
6. [Contribute](docs/CONTRIBUTE.md)
7. [Known issues](docs/known_issues.md)

To learn more about controllers, configuration files and how argos works, refer to [Argos documentation](https://www.argos-sim.info/documentation.php), the [Argos github repository](https://github.com/ilpincy/argos3), and the [Argos robot examples](https://github.com/ilpincy/argos3-examples).

































