#ifndef MYBOT_BRIDGE_H
#define MYBOT_BRIDGE_H


#include <tr1/functional>
#include <string>

#include <argos3/core/control_interface/ci_controller.h>
/* Definition of the differential steering actuator */
#include <argos3/plugins/robots/generic/control_interface/ci_differential_steering_actuator.h>
/* Definition of the foot-bot proximity sensor */
#include <argos3/plugins/robots/foot-bot/control_interface/ci_footbot_proximity_sensor.h>
/* Definition of the omnidirectional camera sensor */
#include <argos3/plugins/robots/generic/control_interface/ci_colored_blob_omnidirectional_camera_sensor.h>
/* Definition of the foot-bot light sensor */
#include <argos3/plugins/robots/foot-bot/control_interface/ci_footbot_light_sensor.h>

#include <argos3/core/utility/math/vector2.h>

using namespace argos;

class Mybot {

private:

    std::string m_name = "";
    bool m_initialized = false;

public:

    void init(const std::string & id);

    /*
     * Simulated ID. This function assumes that each robot have a unique name.
     * The hash of the name's string is calculated to produce the ID
     */
    std::string getId();

    /*
     * Simulated name. This name is read from the .argos config file
     */
    inline std::string getName() { return m_name; }

    inline bool have_name() { return m_name.length() > 0; }

    inline bool isInitialized() { return m_initialized; }

    /*
     * Mock up functions
     */
    inline void setup() { }

   inline void loop() {}

    static void set_DISTANCE_RATIO_MYBOT(Real _DISTANCE_RATIO_MYBOT)
    {
    }

};

#endif