/**
 * @file <argos3/plugins/simulator/robots/my-bot/simulator/pointmass3d/pointmass3d_mybot_model.h>
 *
 * @author Carlo Pinciroli - <cpinciro@ulb.ac.be>
 */

#ifndef POINTMASS3D_MYBOT_H
#define POINTMASS3D_MYBOT_H

namespace argos {
   class CPointMass3DEngine;
   class CPointMass3DMyBotModel;
   class CMyBotEntity;
}

#include <argos3/plugins/simulator/physics_engines/pointmass3d/pointmass3d_model.h>
#include <argos3/core/simulator/entity/embodied_entity.h>
#include <argos3/plugins/robots/mybot/simulator/mybot_entity.h>

namespace argos {

   class CPointMass3DMyBotModel : public CPointMass3DModel {

   public:
      
      CPointMass3DMyBotModel(CPointMass3DEngine& c_engine,
                               CMyBotEntity& c_mybot);

      virtual ~CPointMass3DMyBotModel() {}
      
      virtual void Reset();

      virtual void UpdateFromEntityStatus();
      virtual void Step();

      virtual void CalculateBoundingBox();

      virtual bool CheckIntersectionWithRay(Real& f_t_on_ray,
                                            const CRay3& c_ray) const;

      virtual void UpdateOriginAnchor(SAnchor& s_anchor);

   private:

      /** Reference to the wheeled entity */
      CWheeledEntity& m_cWheeledEntity;

      /** The yaw of the my-bot entity */
      CRadians m_cYaw;

      /** The yaw of the my-bot entity */
      Real m_fAngularVelocity;

      /** Current wheel velocity */
      const Real* m_fCurrentWheelVelocity;
   };

}

#endif
